Index: /extensions/UserAdvManager/trunk/admin/UAM_admin.php
===================================================================
--- /extensions/UserAdvManager/trunk/admin/UAM_admin.php	(revision 17917)
+++ /extensions/UserAdvManager/trunk/admin/UAM_admin.php	(revision 17918)
@@ -991,81 +994,81 @@
 // |                            selected users                             |
 // +-----------------------------------------------------------------------+
-		if (isset($_POST['Mail_With_Key']))
-		{
-  		$collection = array();
-
-			switch ($_POST['target'])
-    	{
-    		case 'all' :
-      	{
-      		foreach($page['filtered_users'] as $local_user)
-        	{
-        		array_push($collection, $local_user['id']);
-        	}
-        	break;
-				}
-      	case 'selection' :
-      	{
-      		if (isset($_POST['selection']))
-        	{
-        		$collection = $_POST['selection'];
-        	}
-        	break;
-      	}
-			}
-
-    	if (count($collection) == 0)
-    	{
-    		array_push($page['errors'], l10n('Select at least one user'));
-    	}
-		}
+				if (isset($_POST['Mail_With_Key']))
+				{
+  				$collection = array();
+
+						switch ($_POST['target'])
+    		{
+    				case 'all' :
+      		{
+      				foreach($page['filtered_users'] as $local_user)
+        		{
+        				array_push($collection, $local_user['id']);
+        		}
+      		break;
+								}
+      		case 'selection' :
+      		{
+      				if (isset($_POST['selection']))
+        		{
+        				$collection = $_POST['selection'];
+       			}
+       	break;
+      		}
+						}
+
+    		if (count($collection) == 0)
+    		{
+    				array_push($page['errors'], l10n('Select at least one user'));
+    		}
+				}
 // +-----------------------------------------------------------------------+
 // |                 Resend new validation key to users                    |
 // +-----------------------------------------------------------------------+
-		if (isset($_POST['Mail_With_Key']) and count($collection) > 0)
-		{
-			if (in_array($conf['guest_id'], $collection))
-   		{
-    		array_push($page['errors'], l10n('UAM_No_validation_for_Guest'));
-    	}
-    	if (($conf['guest_id'] != $conf['default_user_id']) and
-    		in_array($conf['default_user_id'], $collection))
-    	{
-    		array_push($page['errors'], l10n('UAM_No_validation_for_default_user'));
-    	}
-   		if (in_array($conf['webmaster_id'], $collection))
-    	{
-    		array_push($page['errors'], l10n('UAM_No_validation_for_Webmaster'));
-    	}
-    	if (in_array($user['id'], $collection))
-    	{
-    		array_push($page['errors'], l10n('UAM_No_validation_for_your_account'));
-    	}
-
-    	if (count($page['errors']) == 0)
-    	{
-    		foreach ($collection as $user_id)
-      	{     	
-      		$typemail = 1;
-				  $query = "
+				if (isset($_POST['Mail_With_Key']) and count($collection) > 0)
+				{
+						if (in_array($conf['guest_id'], $collection))
+   			{
+    				array_push($page['errors'], l10n('UAM_No_validation_for_Guest'));
+   			}
+    		if (($conf['guest_id'] != $conf['default_user_id']) and
+    				in_array($conf['default_user_id'], $collection))
+    		{
+    				array_push($page['errors'], l10n('UAM_No_validation_for_default_user'));
+   			}
+   			if (in_array($conf['webmaster_id'], $collection))
+    		{
+    				array_push($page['errors'], l10n('UAM_No_validation_for_Webmaster'));
+    		}
+    		if (in_array($user['id'], $collection))
+    		{
+    				array_push($page['errors'], l10n('UAM_No_validation_for_your_account'));
+    		}
+
+    		if (count($page['errors']) == 0)
+    		{
+    				foreach ($collection as $user_id)
+      		{     	
+      				$typemail = 1;
+				  				$query = '
 SELECT id, username, mail_address
-  FROM ".USERS_TABLE."
-WHERE id = '".$user_id."'
-;";
-					$data = pwg_db_fetch_assoc(pwg_query($query));
+  FROM '.USERS_TABLE.'
+WHERE id = '.$user_id.'
+;';
+										$data = pwg_db_fetch_assoc(pwg_query($query));
 				
-      		ResendMail2User($typemail,$user_id,stripslashes($data['username']),$data['mail_address'],true);
-      	}
-      	array_push(
-      		$page['infos'],
-        	l10n_dec(
-        		'UAM_%d_Mail_With_Key', 'UAM_%d_Mails_With_Key',
-        	count($collection)
-        	)
-      	);
+      				ResendMail2User($typemail,$user_id,stripslashes($data['username']),$data['mail_address'],true);
+      		}
+      		array_push(
+      				$page['infos'],
+       					l10n_dec(
+        				'UAM_%d_Mail_With_Key', 'UAM_%d_Mails_With_Key',
+        				count($collection)
+        				)
+      				);
       	
-				$page['filtered_users'] = get_unvalid_user_list();
-			}
-		}
+								$page['filtered_users'] = get_unvalid_user_list();
+						}
+				}
 
 // +-----------------------------------------------------------------------+
@@ -1075,159 +1078,159 @@
 // |                            selected users                             |
 // +-----------------------------------------------------------------------+
-		if (isset($_POST['Mail_Without_Key']))
-		{
-  		$collection = array();
-
-			switch ($_POST['target'])
-    	{
-    		case 'all' :
-      	{
-      		foreach($page['filtered_users'] as $local_user)
-        	{
-        		array_push($collection, $local_user['id']);
-        	}
-        	break;
-				}
-      	case 'selection' :
-      	{
-      		if (isset($_POST['selection']))
-        	{
-        		$collection = $_POST['selection'];
-        	}
-        	break;
-      	}
-			}
-
-    	if (count($collection) == 0)
-    	{
-    		array_push($page['errors'], l10n('Select at least one user'));
-    	}
-		}
+				if (isset($_POST['Mail_Without_Key']))
+				{
+  				$collection = array();
+
+						switch ($_POST['target'])
+    		{
+    				case 'all' :
+      		{
+      				foreach($page['filtered_users'] as $local_user)
+        		{
+        				array_push($collection, $local_user['id']);
+        		}
+       	break;
+								}
+      		case 'selection' :
+      		{
+     					if (isset($_POST['selection']))
+        		{
+        				$collection = $_POST['selection'];
+        		}
+       	break;
+      		}
+						}
+
+    		if (count($collection) == 0)
+    		{
+    				array_push($page['errors'], l10n('Select at least one user'));
+   			}
+				}
 // +-----------------------------------------------------------------------+
 // |             Send reminder without new key to users                    |
 // +-----------------------------------------------------------------------+
-		if (isset($_POST['Mail_Without_Key']) and count($collection) > 0)
-		{
-			if (in_array($conf['guest_id'], $collection))
-   		{
-    		array_push($page['errors'], l10n('UAM_No_validation_for_Guest'));
-    	}
-    	if (($conf['guest_id'] != $conf['default_user_id']) and
-    		in_array($conf['default_user_id'], $collection))
-    	{
-    		array_push($page['errors'], l10n('UAM_No_validation_for_default_user'));
-    	}
-   		if (in_array($conf['webmaster_id'], $collection))
-    	{
-    		array_push($page['errors'], l10n('UAM_No_validation_for_Webmaster'));
-    	}
-    	if (in_array($user['id'], $collection))
-    	{
-    		array_push($page['errors'], l10n('UAM_No_validation_for_your_account'));
-    	}
-
-    	if (count($page['errors']) == 0)
-    	{
-    		foreach ($collection as $user_id)
-      	{
-      		$typemail = 2;
-				  $query = "
+				if (isset($_POST['Mail_Without_Key']) and count($collection) > 0)
+				{
+						if (in_array($conf['guest_id'], $collection))
+   			{
+    				array_push($page['errors'], l10n('UAM_No_validation_for_Guest'));
+    		}
+    		if (($conf['guest_id'] != $conf['default_user_id']) and
+    				in_array($conf['default_user_id'], $collection))
+    		{
+    				array_push($page['errors'], l10n('UAM_No_validation_for_default_user'));
+    		}
+   			if (in_array($conf['webmaster_id'], $collection))
+    		{
+    				array_push($page['errors'], l10n('UAM_No_validation_for_Webmaster'));
+    		}
+    		if (in_array($user['id'], $collection))
+    		{
+    				array_push($page['errors'], l10n('UAM_No_validation_for_your_account'));
+    		}
+
+    		if (count($page['errors']) == 0)
+    		{
+    				foreach ($collection as $user_id)
+      		{
+      				$typemail = 2;
+				  				$query = '
 SELECT id, username, mail_address
-  FROM ".USERS_TABLE."
-WHERE id = '".$user_id."'
-;";
+  FROM '.USERS_TABLE.'
+WHERE id = '.$user_id.'
+;';
 					
-					$data = pwg_db_fetch_assoc(pwg_query($query));
+										$data = pwg_db_fetch_assoc(pwg_query($query));
 				
-      		ResendMail2User($typemail,$user_id,stripslashes($data['username']),$data['mail_address'],false);				
-      	}
-      	array_push(
-      		$page['infos'],
-        	l10n_dec(
-        		'UAM_%d_Reminder_Sent', 'UAM_%d_Reminders_Sent',
-       		count($collection)
-        	)
-      	);
+      				ResendMail2User($typemail,$user_id,stripslashes($data['username']),$data['mail_address'],false);				
+      		}
+      		array_push(
+      				$page['infos'],
+       			l10n_dec(
+       			'UAM_%d_Reminder_Sent', 'UAM_%d_Reminders_Sent',
+       			count($collection)
+        		)
+      		);
         
-				$page['filtered_users'] = get_unvalid_user_list();
-			}
-		}
-
+								$page['filtered_users'] = get_unvalid_user_list();
+						}
+				}
+
+// +-----------------------------------------------------------------------+
+// |             								 Manual validation	by admins 				                 |
+// +-----------------------------------------------------------------------+
+// +-----------------------------------------------------------------------+
+// |                            selected users                             |
+// +-----------------------------------------------------------------------+
+				if (isset($_POST['Manual_Validation']))
+				{
+  				$collection = array();
+
+						switch ($_POST['target'])
+    		{
+    				case 'all' :
+      		{
+      				foreach($page['filtered_users'] as $local_user)
+        		{
+        				array_push($collection, $local_user['id']);
+        		}
+       	break;
+								}
+      		case 'selection' :
+      		{
+      				if (isset($_POST['selection']))
+        		{
+        				$collection = $_POST['selection'];
+        		}
+      		break;
+      		}
+						}
+
+						if (count($collection) == 0)
+    		{
+    				array_push($page['errors'], l10n('Select at least one user'));
+    		}
+				}
 // +-----------------------------------------------------------------------+
 // |             								Force validation					                 |
 // +-----------------------------------------------------------------------+
-// +-----------------------------------------------------------------------+
-// |                            selected users                             |
-// +-----------------------------------------------------------------------+
-		if (isset($_POST['Force_Validation']))
-		{
-  		$collection = array();
-
-			switch ($_POST['target'])
-    	{
-    		case 'all' :
-      	{
-      		foreach($page['filtered_users'] as $local_user)
-        	{
-        		array_push($collection, $local_user['id']);
-        	}
-        	break;
-				}
-      	case 'selection' :
-      	{
-      		if (isset($_POST['selection']))
-        	{
-        		$collection = $_POST['selection'];
-        	}
-        	break;
-      	}
-			}
-
-    	if (count($collection) == 0)
-    	{
-    		array_push($page['errors'], l10n('Select at least one user'));
-    	}
-		}
-// +-----------------------------------------------------------------------+
-// |             								Force validation					                 |
-// +-----------------------------------------------------------------------+
-		if (isset($_POST['Force_Validation']) and count($collection) > 0)
-		{
-			if (in_array($conf['guest_id'], $collection))
-   		{
-    		array_push($page['errors'], l10n('UAM_No_validation_for_Guest'));
-    	}
-    	if (($conf['guest_id'] != $conf['default_user_id']) and
-    		in_array($conf['default_user_id'], $collection))
-    	{
-    		array_push($page['errors'], l10n('UAM_No_validation_for_default_user'));
-    	}
-   		if (in_array($conf['webmaster_id'], $collection))
-    	{
-    		array_push($page['errors'], l10n('UAM_No_validation_for_Webmaster'));
-    	}
-    	if (in_array($user['id'], $collection))
-    	{
-    		array_push($page['errors'], l10n('UAM_No_validation_for_your_account'));
-    	}
-
-    	if (count($page['errors']) == 0)
-    	{
-    		foreach ($collection as $user_id)
-      	{
-          ForceValidation($user_id);
+				if (isset($_POST['Manual_Validation']) and count($collection) > 0)
+				{
+						if (in_array($conf['guest_id'], $collection))
+   			{
+    				array_push($page['errors'], l10n('UAM_No_validation_for_Guest'));
+    		}
+    		if (($conf['guest_id'] != $conf['default_user_id']) and
+    				in_array($conf['default_user_id'], $collection))
+    		{
+    				array_push($page['errors'], l10n('UAM_No_validation_for_default_user'));
+    		}
+  				if (in_array($conf['webmaster_id'], $collection))
+    		{
+    				array_push($page['errors'], l10n('UAM_No_validation_for_Webmaster'));
+    		}
+    		if (in_array($user['id'], $collection))
+    		{
+    				array_push($page['errors'], l10n('UAM_No_validation_for_your_account'));
+    		}
+
+    		if (count($page['errors']) == 0)
+    		{
+    				foreach ($collection as $user_id)
+      		{
+        		ManualValidation($user_id);
           validation_mail($user_id);
-      	}
-      	array_push(
-      		$page['infos'],
-        	l10n_dec(
+      		}
+      		array_push(
+      				$page['infos'],
+       			l10n_dec(
         		'UAM_%d_Validated_User', 'UAM_%d_Validated_Users',
-       		count($collection)
-        	)
-      	);
-
-				$page['filtered_users'] = get_unvalid_user_list();
-			}
-		}
+       			count($collection)
+        		)
+      		);
+
+								$page['filtered_users'] = get_unvalid_user_list();
+						}
+				}
 		
 
@@ -1236,5 +1239,5 @@
 // +-----------------------------------------------------------------------+
 
-		$groups[-1] = '------------';
+				$groups[-1] = '------------';
 
     $query = '
@@ -1244,9 +1247,9 @@
 ;';
 
-		$result = pwg_query($query);
+				$result = pwg_query($query);
           
     while ($row = pwg_db_fetch_assoc($result))
     {
-      $groups[$row['id']] = $row['name'];
+    		$groups[$row['id']] = $row['name'];
     }
 
@@ -1255,17 +1258,17 @@
 // +-----------------------------------------------------------------------+
 
-		$profile_url = get_root_url().'admin.php?page=profile&amp;user_id=';
-		$perm_url = get_root_url().'admin.php?page=user_perm&amp;user_id=';
+				$profile_url = get_root_url().'admin.php?page=profile&amp;user_id=';
+				$perm_url = get_root_url().'admin.php?page=user_perm&amp;user_id=';
 
     $visible_user_list = array();
     foreach ($page['filtered_users'] as $num => $local_user)
     {
-      $visible_user_list[] = $local_user;
-		}
-
-		foreach ($visible_user_list as $local_user)
+    		$visible_user_list[] = $local_user;
+				}
+
+				foreach ($visible_user_list as $local_user)
     {
-      $groups_string = preg_replace(
-      	'/(\d+)/e',
+    		$groups_string = preg_replace(
+      		'/(\d+)/e',
         "\$groups['$1']",
         implode(
@@ -1273,5 +1276,5 @@
             $local_user['groups']
          )
-			);
+						);
 
       $query = '
@@ -1294,36 +1297,36 @@
 
 
-	  	if (isset($_POST['pref_submit'])
-    		and isset($_POST['selection'])
-      	and in_array($local_user['id'], $_POST['selection']))
-	  	{
-				$checked = 'checked="checked"';
-	  	}
-			else
-    	{
-    		$checked = '';
-    	}
-
-    	$properties = array();
-    	if ( $local_user['level'] != 0 )
-			{
-    		$properties[] = l10n( sprintf('Level %d', $local_user['level']) );
-			}
-    	$properties[] =
-    		(isset($local_user['enabled_high']) and ($local_user['enabled_high'] == 'true'))
-      		? l10n('is_high_enabled') : l10n('is_high_disabled');
-
-			$expiration = expiration($local_user['id']);
+	  			if (isset($_POST['pref_submit'])
+    				and isset($_POST['selection'])
+     			and in_array($local_user['id'], $_POST['selection']))
+	  			{
+								$checked = 'checked="checked"';
+	  			}
+						else
+    		{
+    				$checked = '';
+   			}
+
+    		$properties = array();
+    		if ( $local_user['level'] != 0 )
+						{
+    				$properties[] = l10n( sprintf('Level %d', $local_user['level']) );
+						}
+    		$properties[] =
+    				(isset($local_user['enabled_high']) and ($local_user['enabled_high'] == 'true'))
+      				? l10n('is_high_enabled') : l10n('is_high_disabled');
+
+						$expiration = expiration($local_user['id']);
 
       // Template initialization
       // -----------------------
-   		$template->append(
-     		'users',
-       	array(
-       		'ID'               => $local_user['id'],
-         	'CHECKED'          => $checked,
-         	'U_PROFILE'        => $profile_url.$local_user['id'],
-         	'U_PERM'           => $perm_url.$local_user['id'],
-         	'USERNAME'         => stripslashes($local_user['username'])
+   			$template->append(
+     			'users',
+       			array(
+      						'ID'               => $local_user['id'],
+         			'CHECKED'          => $checked,
+         			'U_PROFILE'        => $profile_url.$local_user['id'],
+         			'U_PERM'           => $perm_url.$local_user['id'],
+         			'USERNAME'         => stripslashes($local_user['username'])
                                   .($local_user['id'] == $conf['guest_id']
                                   ? '<BR>['.l10n('is_the_guest').']' : '')
@@ -1332,12 +1335,12 @@
                                   'STATUS' => l10n('user_status_'
                                   .$local_user['status']),
-					'EMAIL'            => get_email_address_as_display_text($local_user['email']),
-         	'GROUPS'           => $groups_string,
-         	'REGISTRATION'     => $local_user['registration_date'],
-          'REMINDER'         => $reminder,    
-         	'EXPIRATION'       => $expiration,
-				)
-			);
-		}   
+												'EMAIL'            => get_email_address_as_display_text($local_user['email']),
+         			'GROUPS'           => $groups_string,
+         			'REGISTRATION'     => $local_user['registration_date'],
+          		'REMINDER'         => $reminder,    
+         			'EXPIRATION'       => $expiration,
+										)
+						);
+				}   
 
     // Check if validation of register is made by admin or visitor 
@@ -1358,5 +1361,5 @@
     // -----------------------
     $template->assign(
-      array(
+    		array(
         'CONFIRM_LOCAL'=> $Confirm_Local,
         'UAM_VERSION'  => $version,
@@ -1368,22 +1371,22 @@
 // |                             errors display                            |
 // +-----------------------------------------------------------------------+
-		if ( isset ($errors) and count($errors) != 0)
-		{
-	  	$template->assign('errors',array());
-			foreach ($errors as $error)
-	  	{
-				array_push($page['errors'], $error);
-	  	}
-		}  
+				if ( isset ($errors) and count($errors) != 0)
+				{
+	  			$template->assign('errors',array());
+						foreach ($errors as $error)
+	  			{
+								array_push($page['errors'], $error);
+	  			}
+				}  
 
 // +-----------------------------------------------------------------------+
 // |                           templates display                           |
 // +-----------------------------------------------------------------------+
-		$template->set_filename('plugin_admin_content', dirname(__FILE__) . '/template/usermanager.tpl');
-    $template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');		
-	}
+				$template->set_filename('plugin_admin_content', dirname(__FILE__) . '/template/usermanager.tpl');
+  		$template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');		
+		}
   else
   {
-		array_push($page['errors'], l10n('UAM_Err_UserManager_Settings'));
+				array_push($page['errors'], l10n('UAM_Err_UserManager_Settings'));
   }
   break;
@@ -1395,5 +1398,5 @@
 // +-----------------------------------------------------------------------+
 // *************************************************************************
-  case 'ghosttracker':
+		case 'ghosttracker':
 
   $conf_UAM = unserialize($conf['UserAdvManager']);
@@ -1405,15 +1408,15 @@
 // +-----------------------------------------------------------------------+
 
-		if (!defined('PHPWG_ROOT_PATH'))
-    {
-    	die('Hacking attempt!');
-    }
+				if (!defined('PHPWG_ROOT_PATH'))
+  		{
+  				die('Hacking attempt!');
+  		}
           
-    include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
+  		include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
 
 // +-----------------------------------------------------------------------+
 // | Check Access and exit when user status is not ok                      |
 // +-----------------------------------------------------------------------+
-		check_status(ACCESS_ADMINISTRATOR);
+				check_status(ACCESS_ADMINISTRATOR);
 
 // +-----------------------------------------------------------------------+
@@ -1421,85 +1424,85 @@
 // +-----------------------------------------------------------------------+
 
-		$page['filtered_users'] = get_ghost_user_list();
+				$page['filtered_users'] = get_ghost_user_list();
 
 // +-----------------------------------------------------------------------+
 // |                            selected users                             |
 // +-----------------------------------------------------------------------+
-		if (isset($_POST['Del_Selected']))
-		{
-  		$collection = array();
-
-			switch ($_POST['target'])
-    	{
-    		case 'all' :
-      	{
-      		foreach($page['filtered_users'] as $local_user)
-        	{
-        		array_push($collection, $local_user['id']);
-        	}
-					break;
-				}
-      	case 'selection' :
-      	{
-      		if (isset($_POST['selection']))
-        	{
-        		$collection = $_POST['selection'];
-        	}
-        	break;
-      	}
-			}
-
-			if (count($collection) == 0)
-    	{
-    		array_push($page['errors'], l10n('Select at least one user'));
-   		}
-		}
+				if (isset($_POST['Del_Selected']))
+				{
+  				$collection = array();
+
+						switch ($_POST['target'])
+    		{
+    				case 'all' :
+      		{
+      				foreach($page['filtered_users'] as $local_user)
+      				{
+        				array_push($collection, $local_user['id']);
+       			}
+								break;
+								}
+      		case 'selection' :
+      		{
+      				if (isset($_POST['selection']))
+        		{
+        				$collection = $_POST['selection'];
+        		}
+      		break;
+      		}
+						}
+
+						if (count($collection) == 0)
+    		{
+    				array_push($page['errors'], l10n('Select at least one user'));
+   			}
+				}
 
 // +-----------------------------------------------------------------------+
 // |                             delete users                              |
 // +-----------------------------------------------------------------------+
-		if (isset($_POST['Del_Selected']) and count($collection) > 0)
-  	{
-  		if (in_array($conf['guest_id'], $collection))
-   		{
-    		array_push($page['errors'], l10n('Guest cannot be deleted'));
-    	}
-    	if (($conf['guest_id'] != $conf['default_user_id']) and
-    		in_array($conf['default_user_id'], $collection))
-    	{
-    		array_push($page['errors'], l10n('Default user cannot be deleted'));
-    	}
-    	if (in_array($conf['webmaster_id'], $collection))
-    	{
-    		array_push($page['errors'], l10n('Webmaster cannot be deleted'));
-    	}
-    	if (in_array($user['id'], $collection))
-    	{
-    		array_push($page['errors'], l10n('You cannot delete your account'));
-    	}
-
-			if (count($page['errors']) == 0)
-    	{
-    		foreach ($collection as $user_id)
-      	{
-      		delete_user($user_id);
-      	}
-     		array_push(
-      		$page['infos'],
-        	l10n_dec(
-        	'%d user deleted', '%d users deleted',
-        	count($collection)
-        	)
-      	);
-
-      	foreach ($page['filtered_users'] as $filter_key => $filter_user)
-      	{
-      		if (in_array($filter_user['id'], $collection))
-        	{
-        		unset($page['filtered_users'][$filter_key]);
-        	}
-     		}
-			}
-		}
+				if (isset($_POST['Del_Selected']) and count($collection) > 0)
+  		{
+  				if (in_array($conf['guest_id'], $collection))
+   			{
+    				array_push($page['errors'], l10n('Guest cannot be deleted'));
+    		}
+    		if (($conf['guest_id'] != $conf['default_user_id']) and
+    				in_array($conf['default_user_id'], $collection))
+    		{
+    				array_push($page['errors'], l10n('Default user cannot be deleted'));
+    		}
+    		if (in_array($conf['webmaster_id'], $collection))
+    		{
+    				array_push($page['errors'], l10n('Webmaster cannot be deleted'));
+    		}
+    		if (in_array($user['id'], $collection))
+    		{
+    				array_push($page['errors'], l10n('You cannot delete your account'));
+    		}
+
+						if (count($page['errors']) == 0)
+    		{
+    				foreach ($collection as $user_id)
+      		{
+      				delete_user($user_id);
+      		}
+     			array_push(
+      				$page['infos'],
+        		l10n_dec(
+        		'%d user deleted', '%d users deleted',
+        		count($collection)
+        		)
+      		);
+
+      		foreach ($page['filtered_users'] as $filter_key => $filter_user)
+      		{
+      				if (in_array($filter_user['id'], $collection))
+        		{
+        				unset($page['filtered_users'][$filter_key]);
+        		}
+     			}
+						}
+				}
 
 // +-----------------------------------------------------------------------+
@@ -1509,85 +1512,85 @@
 // |                            selected users                             |
 // +-----------------------------------------------------------------------+
-		if (isset($_POST['Reminder_Email']))
-		{
-  		$collection = array();
-
-			switch ($_POST['target'])
-    	{
-    		case 'all' :
-      	{
-      		foreach($page['filtered_users'] as $local_user)
-        	{
-        		array_push($collection, $local_user['id']);
-        	}
-        	break;
-				}
-      	case 'selection' :
-      	{
-      		if (isset($_POST['selection']))
-        	{
-        		$collection = $_POST['selection'];
-        	}
-        	break;
-      	}
-			}
-
-    	if (count($collection) == 0)
-    	{
-    		array_push($page['errors'], l10n('Select at least one user'));
-    	}
-		}
+				if (isset($_POST['Reminder_Email']))
+				{
+  				$collection = array();
+
+						switch ($_POST['target'])
+    		{
+    				case 'all' :
+      		{
+      				foreach($page['filtered_users'] as $local_user)
+        		{
+        				array_push($collection, $local_user['id']);
+        		}
+       	break;
+								}
+      		case 'selection' :
+      		{
+      				if (isset($_POST['selection']))
+        		{
+        				$collection = $_POST['selection'];
+        		}
+      		break;
+      		}
+						}
+
+    		if (count($collection) == 0)
+    		{
+    				array_push($page['errors'], l10n('Select at least one user'));
+    		}
+				}
 // +-----------------------------------------------------------------------+
 // |                         Send ghost reminder                           |
 // +-----------------------------------------------------------------------+
-		if (isset($_POST['Reminder_Email']) and count($collection) > 0)
-		{
-			if (in_array($conf['guest_id'], $collection))
-   		{
-    		array_push($page['errors'], l10n('UAM_No_reminder_for_Guest'));
-    	}
-    	if (($conf['guest_id'] != $conf['default_user_id']) and
-    		in_array($conf['default_user_id'], $collection))
-    	{
-    		array_push($page['errors'], l10n('UAM_No_reminder_for_default_user'));
-    	}
-   		if (in_array($conf['webmaster_id'], $collection))
-    	{
-    		array_push($page['errors'], l10n('UAM_No_reminder_for_Webmaster'));
-    	}
-    	if (in_array($user['id'], $collection))
-    	{
-    		array_push($page['errors'], l10n('UAM_No_reminder_for_your_account'));
-    	}
-
-    	if (count($page['errors']) == 0)
-    	{
-    		foreach ($collection as $user_id)
-      	{
-				  $query = "
+				if (isset($_POST['Reminder_Email']) and count($collection) > 0)
+				{
+						if (in_array($conf['guest_id'], $collection))
+   			{
+    				array_push($page['errors'], l10n('UAM_No_reminder_for_Guest'));
+   			}
+    		if (($conf['guest_id'] != $conf['default_user_id']) and
+    				in_array($conf['default_user_id'], $collection))
+    		{
+    				array_push($page['errors'], l10n('UAM_No_reminder_for_default_user'));
+    		}
+   			if (in_array($conf['webmaster_id'], $collection))
+    		{
+    				array_push($page['errors'], l10n('UAM_No_reminder_for_Webmaster'));
+    		}
+    		if (in_array($user['id'], $collection))
+    		{
+    				array_push($page['errors'], l10n('UAM_No_reminder_for_your_account'));
+   			}
+
+    		if (count($page['errors']) == 0)
+    		{
+    				foreach ($collection as $user_id)
+      		{
+				  				$query = '
 SELECT id, username, mail_address
-  FROM ".USERS_TABLE."
-WHERE id = '".$user_id."'
-;";
+  FROM '.USERS_TABLE.'
+WHERE id = '.$user_id.'
+;';
 					
-					$data = pwg_db_fetch_assoc(pwg_query($query));
+										$data = pwg_db_fetch_assoc(pwg_query($query));
 				
-      		ghostreminder($user_id,stripslashes($data['username']),$data['mail_address']);				
-      	}
-      	array_push(
-      		$page['infos'],
-        	l10n_dec(
-        		'UAM_%d_Reminder_Sent', 'UAM_%d_Reminders_Sent',
-       		count($collection)
-        	)
-      	);
-      	
-				$page['filtered_users'] = get_ghost_user_list();
-			}
-		}
+      				ghostreminder($user_id,stripslashes($data['username']),$data['mail_address']);				
+      		}
+      		array_push(
+      				$page['infos'],
+        		l10n_dec(
+       			'UAM_%d_Reminder_Sent', 'UAM_%d_Reminders_Sent',
+       			count($collection)
+        		)
+      		);
+
+								$page['filtered_users'] = get_ghost_user_list();
+						}
+				}
     
     if (isset($_POST['GhostTracker_Init']) and is_admin()) //Reset is only allowed for admins !
     {
-      $query1 = '
+    		$query1 = '
 SELECT *
   FROM '.USER_LASTVISIT_TABLE.';';
@@ -1597,5 +1600,5 @@
       if ($count <> 0)
       {
-        $query = '
+      		$query = '
 SELECT DISTINCT u.id,
                 ui.status AS status
@@ -1616,8 +1619,9 @@
           list($dbnow) = pwg_db_fetch_row(pwg_query('SELECT NOW();'));
             
-          $query = "
-INSERT INTO ".USER_LASTVISIT_TABLE." (user_id, lastvisit, reminder)
-VALUES ('".$row['id']."','".$dbnow."','false')
-;";
+          $query = '
+INSERT INTO '.USER_LASTVISIT_TABLE.'
+				(user_id, lastvisit, reminder)
+VALUES ('.$row['id'].',"'.$dbnow.'","false")
+;';
           pwg_query($query);
         }
@@ -1643,8 +1647,9 @@
           list($dbnow) = pwg_db_fetch_row(pwg_query('SELECT NOW();'));
             
-          $query = "
-INSERT INTO ".USER_LASTVISIT_TABLE." (user_id, lastvisit, reminder)
-VALUES ('".$row['id']."','".$dbnow."','false')
-;";
+          $query = '
+INSERT INTO '.USER_LASTVISIT_TABLE.'
+    (user_id, lastvisit, reminder)
+VALUES ('.$row['id'].',"'.$dbnow.'","false")
+;';
           pwg_query($query);
         }
@@ -1662,9 +1667,9 @@
     {
       $visible_user_list[] = $local_user;
-		}
+				}
     
-		foreach ($visible_user_list as $local_user)
-    {
-      $reminder = '';
+				foreach ($visible_user_list as $local_user)
+   	{
+    		$reminder = '';
     
       if (isset($local_user['reminder']) and $local_user['reminder'] == 'true')
